'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EMOJIS = exports.EMOTICON_TO_UNICODE = exports.SHORTCODE_TO_UNICODE = exports.UNICODE_TO_SHORTCODES = undefined;
exports.parseEmojiData = parseEmojiData;

var _emojibase = require('emojibase');

var _constants = require('emojibase/lib/constants');

/**
 * @copyright   2016, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 * 
 */

var UNICODE_TO_SHORTCODES = exports.UNICODE_TO_SHORTCODES = {};
var SHORTCODE_TO_UNICODE = exports.SHORTCODE_TO_UNICODE = {};
var EMOTICON_TO_UNICODE = exports.EMOTICON_TO_UNICODE = {};
var EMOJIS = exports.EMOJIS = {};

function parseEmojiData(data) {
  (0, _emojibase.flattenEmojiData)(data).forEach(function (emoji) {
    var emoticon = emoji.emoticon,
        _emoji$shortcodes = emoji.shortcodes,
        shortcodes = _emoji$shortcodes === undefined ? [] : _emoji$shortcodes;

    var unicode = emoji.text && emoji.type === _constants.TEXT ? emoji.text : emoji.emoji;

    UNICODE_TO_SHORTCODES[unicode] = shortcodes.map(function (code) {
      var shortcode = ':' + code + ':';

      SHORTCODE_TO_UNICODE[shortcode] = unicode;

      return shortcode;
    });

    if (emoticon) {
      (0, _emojibase.generateEmoticonPermutations)(emoticon).forEach(function (emo) {
        EMOTICON_TO_UNICODE[emo] = unicode;
      });
    }

    EMOJIS[unicode] = emoji;
  });
}