'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _emojibase = require('emojibase');

var _constants = require('emojibase/lib/constants');

var _emoji = require('../data/emoji');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var loaded = false; /**
                     * @copyright   2016, Miles Johnson
                     * @license     https://opensource.org/licenses/MIT
                     * 
                     */

var promise = null;

var EmojiLoader = function (_React$Component) {
  (0, _inherits3.default)(EmojiLoader, _React$Component);

  function EmojiLoader() {
    (0, _classCallCheck3.default)(this, EmojiLoader);
    return (0, _possibleConstructorReturn3.default)(this, (EmojiLoader.__proto__ || (0, _getPrototypeOf2.default)(EmojiLoader)).apply(this, arguments));
  }

  (0, _createClass3.default)(EmojiLoader, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _this2 = this;

      var _props = this.props,
          data = _props.data,
          locale = _props.locale,
          version = _props.version;

      if (loaded) {
        return;
      }

      if (data.length > 0) {
        this.loadData(data);
      } else if (promise) {
        promise.then(function () {
          _this2.forceUpdate();
        }).catch(function (error) {
          throw error;
        });
      } else {
        promise = (0, _emojibase.fetchFromCDN)(locale + '/compact.json', version).then(function (response) {
          _this2.loadData(response);
        }).catch(function (error) {
          throw error;
        });
      }
    }
  }, {
    key: 'loadData',
    value: function loadData(data) {
      loaded = true;

      (0, _emoji.parseEmojiData)(typeof data === 'string' ? JSON.parse(data) : data);

      this.forceUpdate();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          children = _props2.children,
          locale = _props2.locale,
          props = (0, _objectWithoutProperties3.default)(_props2, ['children', 'locale']);

      return _react2.default.cloneElement(_react2.default.Children.only(children), props);
    }
  }]);
  return EmojiLoader;
}(_react2.default.Component);

EmojiLoader.propTypes = {
  children: _propTypes2.default.node.isRequired,
  data: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.arrayOf(_propTypes2.default.object)]),
  locale: _propTypes2.default.oneOf(_constants.SUPPORTED_LOCALES),
  version: _propTypes2.default.string
};
EmojiLoader.defaultProps = {
  data: [],
  locale: 'en',
  version: 'latest'
};
exports.default = EmojiLoader;